#!/bin/sh
#-----------------------------------------------------------#
# ファイルを Perl 正規表現で書き換えるスクリプト
#
# 呼出 : renew.sh regex filename
# 引数 : regex : perl の正規表現 (例. 's/AAA/BBB/g')
#        filename : 書き換えたいファイル (例. /tmp/test.txt)
# 返り値: なし
#
# 2008/12/1 SoSO
#-----------------------------------------------------------#

# Perl の正規表現
REGEX="$1"

# 書き換えたいファイル
FILE="$2"

# テンポラリファイルを作成
tempfile=$(mktemp -p /tmp)

# 置換した内容をテンポラリファイルに書き込む
perl -pe "$REGEX" "$FILE" > "$tempfile"

# 元のファイルのオーナー・グループ・パーミッションを適用する
chown --reference="$FILE" "$tempfile"
chgrp --reference="$FILE" "$tempfile"
chmod --reference="$FILE" "$tempfile"

# 元のファイルを上書きする
mv "$tempfile" "$FILE"
/sbin/restorecon "$FILE"
